#ifndef DBOX_ASYNCIO_H

#define DBOX_ASYNCIO_H

#include <vector.h>
#include <list.h>
#include <string>

class io_channelt
 {
 public:
  int handle;
  string buffer;
  io_channelt();
  ~io_channelt();
 };

class asynciot
 {
 public:  
  void write(int handle, const char *data, size_t len);
  bool input(const vector<int> &handles);
  void drop_output(int handle);
  void drop_output();
  void do_output(io_channelt &io_channel);
  void make_async(int handle);
  void flush_output();
  bool output_pending(int handle);
  
  bool initialize();
  void clear();
 
 protected:
  void write(io_channelt &io_channel, const char *data, size_t len);
  vector<io_channelt> *channels;
 };
 
extern asynciot asyncio;

#endif
