#ifndef DBOX_TOOLS_H

#define DBOX_TOOLS_H

#include <stdio.h>
#include <string>

class filet
 {
 public:
  FILE *file;
  
  bool open(const char *filename, const char *mode);
  void close();
  bool eof();
  size_t read(void *data, size_t size);
  size_t write(void *data, size_t size);
  
  filet() { file=(FILE *)NULL; }
  ~filet() { if(file!=NULL) fclose(file); }
 };

#include <general.h>
#include <stream.h>

dword filelength(int handle);
dword filelength(const char *filename);

bool checkload(byte maxload);

char *readtextconfigfile(const char *filename);
char *readtextconfigfile(FILE *infile);

bool renamedirectory(const char *path, const char *dir);

int readconfigline(istream &in, char *line1, char *line2, word maxlen);
bool filecopy(istream &in, ostream &out, dword size);
bool filecopy(istream &in, int out, dword size);

#endif
