/*

  DBOX Module
  Copyright (C) 1994-2000 Daniel Kroening <kroening@handshake.de>

  Purpose: 

*/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <time.h>

#include <libdbox.h>
#include "online.h"
#include "help.h"
#include "www.h"

void displayhelp(const char *name)
 {
  string url="internal://help/";

  #ifdef DBOX_STANDALONE

  url+="default";

  #else
  char language[TEXTLEN];
  getuser(&status.userprofile, &status.gruppe, "language", language);

  if(language[0]==0)
    url+="default";
  else
    url+=language;
  #endif
 
  url+='/';
  url+=name;

  do_www(url);
 }
