#ifndef DBOX_ISOCKETT_H

#define DBOX_ISOCKETT_H

#include <time.h>
#include "sockett.h"

class isockett:public sockett
 {
 public:
  isockett();
  ~isockett();

  virtual size_t read(void *buf, size_t count);
 };

class ibsockett:public isockett
 {
 public:
  ibsockett();
  ~ibsockett();

  virtual bool open(const string &_title, const string &address, word port);
  virtual size_t read(void *buf, size_t count);
  virtual void set_progress_bar(bool read, size_t size);
  virtual void draw_box();

 protected:
  virtual bool really_abort();
  virtual void update_bar(bool force_draw);

  bool box_drawn;
  time_t start, last_char;
  byte char_index;
  string title;
  
  bool progressbar_read;
  size_t progressbar_bytes, progressbar_size;
  unsigned progressbar_width;
 };

#endif
