#ifndef DBOX_CMDLINE_H

#define DBOX_CMDLINE_H

#define CMDLINE_MAXARGS 1000

class cmdlinet
 {
 public:
  bool parse(int argc, char **argv, const char *optstring);
  const char *getval(char option);
  const char *getval(const char *option);
  bool isset(char option);
  bool isset(const char *option);

  void clear();
  
  const char *args[CMDLINE_MAXARGS];
  int argcount;
  
  cmdlinet();
  ~cmdlinet();
  
 private:
  struct optiont
   {
    bool isset, hasval, islong;
    char optchar;
    char *optstring;
    char *value;
   } options[CMDLINE_MAXARGS];
   
  int count;
  
  int getoptnr(char option);
  int getoptnr(const char *option);
 };

#endif
