#ifndef DBOX_RFC822_H

#define DBOX_RFC822_H

#include <string>
#include <vector.h>

struct rfc822symbolt
 {
  enum { SPECIAL, QUOTED, DOMAIN, COMMENT, ATOM, END_OF_LIST } type;
  string text;
 };

void parserfc822symbols(const string &text, 
                        vector<rfc822symbolt> &symbols,
                        const string &extra_specials="");

#endif
