#ifndef DBOX_STRINGTOOLS_H

#define DBOX_STRINGTOOLS_H

#include <string>
#include <libdbox.h>

int stringcasecmp(const string &a, const string &b);
void ibm2ascii(string &s);
void iso2ascii(string &s);
void ibm2iso(string &s);
void iso2ibm(string &s);
void upstringibm(string &s);
void upstringiso(string &s);
void upstring(string &s);
void dnstring(string &s);
string up_string(const string &s);
string dn_string(const string &s);
string i2string(unsigned i);
string i2string(signed i);

bool check_joker(const string &mask, const string &filename,
                 bool casei=FALSE);
// TRUE: ok, FALSE: failed

#endif
