#ifndef DBOX_WINPORT_H

#define DBOX_WINPORT_H

#ifdef OS_WIN32

#include <stdarg.h>
#include <stdlib.h>

int snprintf(char *str, size_t n, const char *format, ...);
int vsnprintf( char *str, size_t n, const char *format, va_list ap);

#define socklen_t int

#else

#ifndef O_BINARY
#define O_BINARY 0
#endif

#endif

#endif
